﻿Type=Class
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mAccessToken As String	
	Private mApiV1url As String = "https://api.dropbox.com/1/"
	Private mApiV1notifyurl As String = "https://api-notify.dropbox.com/1/"
	Private mApiV1urlcontent As String = "https://api-content.dropbox.com/1/"
	Private mApiV2url As String = "https://api.dropboxapi.com/2-beta-2/"
	Private mApiV2urlContent As String = "https://content.dropboxapi.com/2-beta-2/"
																				
	Private mCallback As Object
	Private mEvent As String
	Private mDebug As Boolean
	Private mChunkedUploadPos As Int
	Private mChunkedUploadLength As Int
	Private mChunkedUploadPath As String
	Private mChunkedUploadFilename As String
	Private mUploadlist As List
	Private mVersion As String = "0.85ß"
End Sub

Public Sub GetVersion As String
	Return mVersion
End Sub
public Sub logVersionInfo()
	LogColor("**********************",Colors.Blue)
	LogColor("DrobBox Class V2",Colors.Blue)
	LogColor("implementing DbxAPI",Colors.Blue)
	LogColor("-> API V2-beta2 <-",Colors.Blue)
	LogColor("Class-Version: "&mVersion,Colors.Blue)
	LogColor("**********************",Colors.Blue)
	LogColor("Author: DonManfred",Colors.Blue)
	LogColor("Realname: Manfred Ssykor",Colors.Blue)
	LogColor("eMail: msy1912@gmail.com",Colors.Blue)
	LogColor("**********************",Colors.Blue)
End Sub


'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(CallbackModule As Object, EventName As String, AccessToken As String, debug As Boolean) 
	mCallback = CallbackModule
	mEvent = EventName
	mAccessToken = AccessToken
	mDebug = debug
	mUploadlist.Initialize
End Sub





' API V1 (Dropbox CORE)
Sub request_token()
	'
	Dim job As HttpJob
	job.Initialize("gettoken",Me)
	
			 	
	job.PostString("https://api.dropbox.com/1/oauth/request_token",Null)
	job.Tag = "gettoken"
	'job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	'job.GetRequest.SetHeader("Content-Type", "application/json")
	'job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub authorize(responseType As String, clientid As String, rolerequired As String, force_reapprove As Boolean)
	'
	Dim job As HttpJob
	job.Initialize("oauth2",Me)
	
			 	
	job.Download("https://www.dropbox.com/1/oauth2/authorize?client_id="&clientid&"&force_reapprove="&force_reapprove&"&require_role="&rolerequired&"&response_type="&responseType)
	job.Tag = "oauth"
	'job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	'job.GetRequest.SetHeader("Content-Type", "application/json")
	'job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub GetDownloadLink(path As String)
	Dim job As HttpJob
	job.Initialize("downloadlink",Me)
	job.PostString(mApiV1url&"media/auto/"&path,Null)
	job.Tag = path
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub GetShareFileLink(path As String)
	Dim job As HttpJob
	job.Initialize("sharefile",Me)
	job.Tag = path
	job.PostString(mApiV1url&"shares/auto/"&path,Null)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub GetURLJob(JobID As String)
	Log($"urljob="${JobID}""$)
	Dim Job As HttpJob
	Job.Initialize("saveurljob",Me)
	Job.Tag = JobID
	Job.PostString(mApiV1url&"save_url_job/"&JobID, "")
	Job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	Job.GetRequest.SetHeader("Content-Type", "application/json")
	Job.GetRequest.SetContentType("application/json")
	Job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub GetDelta(cursor As String,locale As String, includeMediaInfo As Boolean)
	Log($"GetDelta()"$)
	Dim Job As HttpJob
	Job.Initialize("getdelta",Me)
	Job.Tag = "delta"
	'Log(mApiV1url&"delta?cursor="&cursor&"&locale="&locale&"&include_media_info="&includeMediaInfo)
	Job.PostString(mApiV1url&"delta?cursor="&cursor&"&locale="&locale&"&include_media_info="&includeMediaInfo, "")
	Job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	Job.GetRequest.SetHeader("Content-Type", "application/json")
	Job.GetRequest.SetContentType("application/json")
	Job.GetRequest.SetContentEncoding("text/plain")
End Sub

Sub SaveURL(url As String, destpath As String)
	Log($"url="${url}""$)
	Dim job As HttpJob
	job.Initialize("saveurl",Me)
	job.Tag = url
	job.PostString(mApiV1url&"save_url/auto/"&destpath&"/?url="&url, $"{"url":"${url}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub





'
' API V2 Beta2
'
' MISSING
' /copy
' /move
' /restore
'
' NOT WORKING:
' /get_preview
'


Sub GetAccount(accountID As String)
	Dim job As HttpJob
	job.Initialize("getaccount",Me)
	job.PostString(mApiV2url&"users/get_account",$"{"account_id":"${accountID}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub GetCurrentAccount()
	Dim job As HttpJob
	job.Initialize("getcurrentaccount",Me)
	job.PostString(mApiV2url&"users/get_current_account",Null)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub GetSpaceUsage()
	Dim job As HttpJob
	job.Initialize("getspaceusage",Me)
	job.PostString(mApiV2url&"users/get_space_usage",Null)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub GetMetadata(path As String)
	Dim job As HttpJob
	job.Initialize("getmetadata",Me)
	job.Tag = path
	job.PostString(mApiV2url&"files/get_metadata",$"{"path":"${path}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub Listfolder(path As String)
	Dim job As HttpJob
	job.Initialize("listfolder",Me)
	job.Tag = path
	job.PostString(mApiV2url&"files/list_folder",$"{"path":"${path}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
	
	
	Dim job1 As HttpJob
  job1.Initialize("MyJob", Me)
  job1.Download("https://xxxxxx/xxx-validate")
	job1.PostString("https://xxxxxx/xxx-validate",$"{"number":"1-888-322-113333"}"$)
  job1.GetRequest.SetHeader("X-Mashape-Key", "7ikZQqUI6Fmsh5Sw2lQfqiwxxx1J16Cojsnf7nqE2KYfsqu")
  job1.GetRequest.SetHeader("Content-Type", "application/json")
  job1.GetRequest.SetContentEncoding("text/plain")


	Dim job As HttpJob
	job.Initialize("listfolder",Me)
	job.Tag = path
	job.PostString(mApiV2url&"files/list_folder",$"{"path":"${path}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")

	
End Sub
Sub ListfolderContinue(cursor As String)
	Dim job As HttpJob
	job.Initialize("listfoldercontinue",Me)
	job.Tag = cursor
	job.PostString(mApiV2url&"files/list_folder/continue",$"{"cursor":"${cursor}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub GetLatestCursor(path As String, recursive As Boolean)
	Log($"GetLatestCursor()"$)
	Dim Job As HttpJob
	Job.Initialize("getlatestcursor",Me)
	Job.Tag = "GetLatestCursor"
	Job.PostString(mApiV2url&"files/list_folder/get_latest_cursor", $"{"path": "${path}",
    "recursive": ${recursive}}"$)
	Job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	Job.GetRequest.SetHeader("Content-Type", "application/json")
	Job.GetRequest.SetContentType("application/json")
	Job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub Download(path As String, destpath As String, destfile As String)
	Dim job As HttpJob
	job.Initialize("filedownload",Me)
	job.Tag = File.Combine(destpath,destfile)
	LogColor("Download: "&job.Tag,Colors.Blue)
	job.Download(mApiV2urlContent&"files/download")
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Dropbox-API-Arg", $"{"path":"${path}"}"$)
	job.GetRequest.SetHeader("Accept","application/vnd.dropbox-cors-hack")
End Sub
Sub UploadSessionStart(sessionMap As Map)
	Dim job As HttpJob
	job.Initialize("UploadSessionInit",Me)
	job.Tag = sessionMap
	job.PostString(mApiV2urlContent&"files/upload_session/start","")
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Dropbox-API-Arg", Null)
	'
	'job.GetRequest.SetContentEncoding("text/plain")
	job.GetRequest.SetContentType("text/plain; charset=dropbox-cors-hack")
End Sub

' work in progress
Sub Upload(localpath As String, localFilename As String, dstpath As String, dstfilename As String)
	If mUploadlist.Size > 0 Then
		'if mUploadlist.IndexOf(path) 
	End If
	Dim session As Map 
	session.Initialize
	session.Put("srcpath",localpath)
	session.Put("srcfile",localFilename)
	session.Put("dstpath",dstpath)
	session.Put("dstfile",dstfilename)
	session.Put("status","init")
	
	Dim job As HttpJob
	job.Initialize("fileupload",Me)
	job.Tag = session
	Log($"{"path":"${File.Combine(dstpath,dstfilename)}", "mode": "overwrite"}"$)
	job.PostFile(mApiV2urlContent&"files/upload",localpath,localFilename)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	'job.GetRequest.SetHeader("Content-Type", "application/octet-stream")
	job.GetRequest.SetHeader("Dropbox-API-Arg", $"{"path":"${File.Combine(dstpath,dstfilename)}", "mode": "overwrite"}"$)
	job.GetRequest.SetContentType("application/octet-stream")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub Search(path As String, searchquery As String)
	Dim job As HttpJob
	job.Initialize("filesearch",Me)
	job.PostString(mApiV2url&"files/search",$"{"path":"${path}", "query": "${searchquery}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub CreateFolder(path As String)
	Dim job As HttpJob
	job.Initialize("create_folder",Me)
	job.PostString(mApiV2url&"files/create_folder",$"{"path":"${path}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub copy(fromPath As String, toPath As String)
	Dim job As HttpJob
	job.Initialize("copy",Me)
	job.PostString(mApiV2url&"files/copy",$"{"from_path":"${fromPath}","to_path":"${toPath}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub
Sub move(fromPath As String, toPath As String)
	Dim job As HttpJob
	job.Initialize("copy",Me)
	job.PostString(mApiV2url&"files/move",$"{"from_path":"${fromPath}","to_path":"${toPath}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub

' Not yet finished....
Sub Delete(path As String)
	Dim job As HttpJob
	job.Initialize("delete",Me)
	job.PostString(mApiV2url&"files/delete",$"{"path":"${path}"}"$)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub

' Gets a thumbnail for an image.
'Parameters
' format - jpeg (default) Or png. 
' For images that are photos, jpeg should be preferred, 
' While png Is better For screenshots And digital art.
'
' size One of the following values (default: s):
'value	dimensions (px)
' xs		32x32
' s			64x64
' m			128x128
' l			640x480
' xl		1024x768
'
Sub GetThumbnail(path As String, format As String, size As String)
	Dim job As HttpJob
	job.Initialize("getthumbnail",Me)
	job.Tag = path
	job.PostString(mApiV2urlContent&"files/get_thumbnail","")
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Dropbox-API-Arg", $"{"path":"${path}","format":"${format}","size":"${size}"}"$)
	job.GetRequest.SetContentEncoding("text/plain")
	job.GetRequest.SetContentType("")
End Sub



' Not working as yet!
' It returns a html page instead of a jsonstring
Sub GetPreview(path As String)
	Dim job As HttpJob
	job.Initialize("get_preview",Me)
	job.Tag = path
	job.PostString(mApiV2urlContent&"files/get_preview", "")
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Dropbox-API-Arg", $"{"path": "${path}"}"$)
	job.GetRequest.SetContentEncoding("text/plain")
	'job.GetRequest.SetHeader("Accept","application/json")
	job.GetRequest.SetContentType("")
End Sub

Sub GetRevisions(path As String, revlimit As Int)
	Dim job As HttpJob
	job.Initialize("getrevisions",Me)
	job.Tag = path
	Dim json As String = $"{"path":"${path}","limit":${revlimit}}"$
	Log(json)
	job.PostString(mApiV2url&"files/list_revisions",json)
	job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
	job.GetRequest.SetHeader("Content-Type", "application/json")
	job.GetRequest.SetContentType("application/json")
	job.GetRequest.SetContentEncoding("text/plain")
End Sub

























Sub JobDone(Job As HttpJob)
	If mDebug Then
		Log("JobDone("&Job.JobName&")")
	End If
  ProgressDialogHide

  If Job.Success Then
    Dim res As String
    res=Job.GetString
		If mDebug Then
  	  'Log("JobName: " & Job.JobName)
    	If (Job.JobName <> "filedownload") And (Job.JobName <> "getthumbnail") Then
				'Log("Server response: " & res)
			End If
		End If
    Select Job.JobName
			Case "copy"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				If SubExists(mCallback, mEvent & "_copy") Then
					CallSub2(mCallback, mEvent & "_copy", root)
				End If
			Case "move"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				If SubExists(mCallback, mEvent & "_move") Then
					CallSub2(mCallback, mEvent & "_move", root)
				End If
			Case "UploadSessionInit"
	  	  'Log("JobDone.JobName: " & Job.JobName)
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim session_id As String = root.Get("session_id") 			
				
				Dim session As Map = Job.Tag
				session.Put("sessionID",session_id)
				Log("SESSION: "&session)
				' {srcpath=/storage/emulated/0, srcfile=test.xyz, dstpath=/Export, dstfile=newfilename.zzz, offset=0, packetsize=0, sessionID=AAAAAAAAtfnfd4UP7uheww}
				Dim Job As HttpJob
				Job.Initialize("UploadSessionPostbytes",Me)
				If File.Exists(session.Get("srcpath"),session.Get("srcfile")) Then
					Dim raf As RandomAccessFile
					raf.Initialize(session.Get("srcpath"),session.Get("srcfile"),True)
					mChunkedUploadLength = raf.Size
				
					Dim filesize As Int = File.Size(session.Get("srcpath"),session.Get("srcfile"))
					session.Put("filesize",filesize)
					If session.Get("packetsize") = 0 Then
						session.Put("packetsize",4096)
					End If
					mChunkedUploadPos = session.Get("offset")
					Dim buffer(session.Get("packetsize")) As Byte 
					Dim bytesread As Int = 0
					bytesread = raf.ReadBytes(buffer,0,session.Get("packetsize"),session.Get("offset"))
					Log("ByteRead="&bytesread)
					raf.Close
					session.Put("offset",session.Get("offset")+bytesread)
					Job.Tag = session

					If SubExists(mCallback, mEvent & "_UploadSessionStatus") Then
						CallSub2(mCallback, mEvent & "_UploadSessionStatus", session)
					End If

					' Data() as Byte
					Job.PostBytes(mApiV2urlContent&"files/upload_session/append", buffer)
					Job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
					Job.GetRequest.SetHeader("Dropbox-API-Arg", $"{"session_id": "${session_id}","offset": ${mChunkedUploadPos}}"$)
					Job.GetRequest.SetContentType("application/octet-stream")
				Else
					Log("404 filenotfound: "&File.Combine(session.Get("srcpath"),session.Get("srcfile")))
				End If
				'Job.GetRequest.SetHeader("Content-Type", "application/json")
				'Job.GetRequest.SetContentEncoding("text/plain")
			Case "UploadSessionFinish"
	  	  Log("JobDone.JobName: " & Job.JobName)
				Dim session As Map = Job.Tag
				Log("Session="&session)
				Log(Job.GetString)
				If SubExists(mCallback, mEvent & "_UploadSessionFinish") Then
					CallSub2(mCallback, mEvent & "_UploadSessionFinish", session)
				End If
				
			Case "UploadSessionPostbytes"	
	  	  Log("JobDone.JobName: " & Job.JobName)
				Dim session As Map = Job.Tag
				Log("Session="&session)
				Dim session_id As String = session.Get("sessionID")
				If SubExists(mCallback, mEvent & "_UploadSessionStatus") Then
					CallSub2(mCallback, mEvent & "_UploadSessionStatus", session)
				End If
				
				Dim raf As RandomAccessFile
				raf.Initialize(session.Get("srcpath"),session.Get("srcfile"),True)

				Dim offset As Int = session.Get("offset")
				Log("UploadOffset: "&offset)
	
				
				
				Dim buffer(session.Get("packetsize")) As Byte 
				Dim bytesread As Int = 0
				bytesread = raf.ReadBytes(buffer,0,session.Get("packetsize"),session.Get("offset"))
				raf.Close
				Dim newoffset As Int = offset+bytesread
				session.Put("offset",newoffset)

				Log("NEW offset = "&newoffset)
					
				If newoffset = session.Get("filesize") Then
					LogColor("Last chunk to upload... Should be Uploadsession_finish instead of append now",Colors.Blue)
					Log("UploadOffset = filesize!!! "&offset)		
					Dim Job As HttpJob
					Job.Initialize("UploadSessionFinish",Me)
					Job.PostBytes(mApiV2urlContent&"files/upload_session/finish", buffer)
					Job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
					Job.Tag = session

					'curl -X POST https://content.dropboxapi.com/2-beta-2/files/upload_session/finish \
					'    --header "Authorization: Bearer <access-token>" \
					'    --header "Content-Type: application/octet-stream" \
					'    --header "Dropbox-API-Arg: {\"cursor\": {\"session_id\": \"1234faaf0678bcde\",\"offset\": 0},\"commit\": {\"path\": \"/Homework/math/Matrices.txt\",\"mode\": \"add\",\"autorename\": True,\"mute\": False}}" \
		
					Log($"{"cursor": {"session_id": "${session_id}","offset": ${offset}},"commit": {"path": "${session.Get("dstpath")}/${session.Get("dstfile")}","mode": "add","autorename": true,"mute": false}}"$)
					Job.GetRequest.SetHeader("Dropbox-API-Arg", $"{"cursor": {"session_id": "${session_id}","offset": ${offset}},"commit": {"path": "${session.Get("dstpath")}/${session.Get("dstfile")}","mode": "add","autorename": true,"mute": false}}"$)
					
					Job.GetRequest.SetContentType("application/octet-stream")
				Else
					Dim Job As HttpJob
					Job.Initialize("UploadSessionPostbytes",Me)
					Job.Tag = session
					Job.PostBytes(mApiV2urlContent&"files/upload_session/append", buffer)
					Job.GetRequest.SetHeader("Authorization", "Bearer "&mAccessToken)
					Log($"{"session_id": "${session_id}","offset": ${offset}}"$)
					Job.GetRequest.SetHeader("Dropbox-API-Arg", $"{"session_id": "${session_id}","offset": ${offset}}"$)
					Job.GetRequest.SetContentType("application/octet-stream")
				End If
				' Data() as Byte
				
			Case "get_preview"
				Log("get_preview: " & res)
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				If SubExists(mCallback, mEvent & "_Preview") Then
					CallSub2(mCallback, mEvent & "_Preview", root)
				End If
				
			Case "getspaceusage"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				If SubExists(mCallback, mEvent & "_SpaceUsage") Then
					CallSub2(mCallback, mEvent & "_SpaceUsage", root)
				End If
			
			Case "create_folder"
				LogColor(res,Colors.Magenta)
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim path_lower As String = root.Get("path_lower")
				Dim name As String = root.Get("name") 			
				If SubExists(mCallback, mEvent & "_CreateFolder") Then
					CallSub3(mCallback, mEvent & "_CreateFolder", path_lower, name)
				End If
				
			Case "getthumbnail"
				'Dim bmp As Bitmap
				'bmp.Initialize3(Job.GetBitmap)
				If SubExists(mCallback, mEvent & "_Thumbnail") Then
					CallSub3(mCallback, mEvent & "_Thumbnail", Job.GetBitmap, Job.Tag)
				End If
			Case "getrevisions"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				If SubExists(mCallback, mEvent & "_Revisions") Then
					CallSub2(mCallback, mEvent & "_Revisions", root)
				End If
			Case "getlatestcursor"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				If SubExists(mCallback, mEvent & "_LatestCursor") Then
					CallSub2(mCallback, mEvent & "_LatestCursor", root)
				End If
			Case "getdelta"
        'Dim OutStream As OutputStream
        'OutStream = File.OpenOutput(File.DirDefaultExternal, "getdelta.json", False)
        'File. Copy2(Job.GetInputStream,OutStream)
        'OutStream.Close
				'Log("getdelta.json written to "&File.DirDefaultExternal)			
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				If SubExists(mCallback, mEvent & "_Delta") Then
					CallSub2(mCallback, mEvent & "_Delta", root)
				End If
			Case "saveurljob"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim status As String = root.Get("status")
				Dim JobID As String = root.Get("tag") 
			
			Case "saveurl"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim status As String = root.Get("status")
				Dim saveurlJob As String = root.Get("job") 
				
			Case "filedownload"
				Dim dest As String = GetFilename(Job.Tag)
        Dim OutStream As OutputStream
				Dim pth As String = GetPath(Job.Tag)
				Dim fle As String = GetFilename(Job.Tag)
				Log("DownloadReady: "&Job.Tag)
				Log("DestPath: "&pth)
				Log("DestFilename: "&fle)
        OutStream = File.OpenOutput(pth, fle, False) ' Job.Tag is read to set the Original Filename we specify earlier in the creation of the Job
        File. Copy2(Job.GetInputStream,OutStream) ' save the file
        OutStream.Close
        Log(fle&" are written to "&pth) ' Write the Originalname to the log to see what happens ;-)
				
			Case "fileupload"
				Dim session As Map = Job.Tag
				
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim path As String = root.Get("path_lower")
				Dim rev As String = root.Get("rev")
				Dim name As String = root.Get("name")
				Dim size As Int = root.Get("size")
				Dim client_modified As String = root.Get("client_modified")
				Dim server_modified As String = root.Get("server_modified") 
				session.Put("result",root)
				root.Put("Tag",Job.Tag)
				If SubExists(mCallback, mEvent & "_FileUpload") Then
					CallSub2(mCallback, mEvent & "_FileUpload", session)
				End If
				
			Case "downloadlink"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim expires As String = root.Get("expires")
				Dim url As String = root.Get("url") 
				root.Put("Tag",Job.Tag)
				If SubExists(mCallback, mEvent & "_DownloadLink") Then
					CallSub2(mCallback, mEvent & "_DownloadLink", root)
				End If

			Case "sharefile"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim expires As String = root.Get("expires")
				Dim visibility As String = root.Get("visibility")
				Dim url As String = root.Get("url") 
				root.Put("Tag",Job.Tag)
				If SubExists(mCallback, mEvent & "_ShareFile") Then
					CallSub2(mCallback, mEvent & "_ShareFile", root)
				End If
			Case "getmetadata"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim path_lower As String = root.Get("path_lower")
				Dim rev As String = root.Get("rev")
				Dim name As String = root.Get("name")
				Dim size As Int = root.Get("size")
				Dim tag As String = root.Get(".tag")
				Dim client_modified As String = root.Get("client_modified")
				Dim server_modified As String = root.Get("server_modified") 
				root.Put("Tag",Job.Tag)
				
				If SubExists(mCallback, mEvent & "_MetaData") Then
					CallSub2(mCallback, mEvent & "_MetaData", root)
				End If
			Case "filesearch"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim matches As List = root.Get("matches")
				For Each colmatches As Map In matches
					Dim match_type As Map = colmatches.Get("match_type")
					Dim match_type_tag As String = match_type.Get(".tag")
					Dim metadata As Map = colmatches.Get("metadata")
					Dim path_lower As String = metadata.Get("path_lower")
					Dim name As String = metadata.Get("name")
					Dim metatag As String = metadata.Get(".tag")
				Next
				Dim more As String = root.Get("more")
				Dim start As Int = root.Get("start") 
				If SubExists(mCallback, mEvent & "_FileSearch") Then
					CallSub2(mCallback, mEvent & "_FileSearch", root)
				End If
	    Case "listfolder"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim cursor As String = root.Get("cursor")
				Dim has_more As String = root.Get("has_more")
				Dim entries As List = root.Get("entries")
				For Each colentries As Map In entries
					Dim path_lower As String = colentries.Get("path_lower")
					Dim name As String = colentries.Get("name")
					Dim tag As String = colentries.Get(".tag")
				Next 
				If SubExists(mCallback, mEvent & "_ListFolder") Then
					CallSub2(mCallback, mEvent & "_ListFolder", root)
				End If
	    Case "listfoldercontinue"
				Dim parser As JSONParser
				parser.Initialize(res)
				Dim root As Map = parser.NextObject
				Dim cursor As String = root.Get("cursor")
				Dim has_more As String = root.Get("has_more")
				Dim entries As List = root.Get("entries")
				For Each colentries As Map In entries
					Dim path_lower As String = colentries.Get("path_lower")
					Dim name As String = colentries.Get("name")
					Dim tag As String = colentries.Get(".tag")
				Next 
				If SubExists(mCallback, mEvent & "_ListFolder") Then
					CallSub2(mCallback, mEvent & "_ListFolder", root)
				End If

	  Case "getaccount"
			Dim parser As JSONParser
			parser.Initialize(res)
			'Log(res)
			Dim parser As JSONParser
			parser.Initialize(res)
			Dim root As Map = parser.NextObject
			Dim accis_teammate As String = root.Get("is_teammate")
			Dim acc_accountID As String = root.Get("account_id")
			Dim acc_name As Map = root.Get("name")
			Dim acc_display_name As String = acc_name.Get("display_name")
			Dim acc_familiar_name As String = acc_name.Get("familiar_name")
			Dim acc_surname As String = acc_name.Get("surname")
			Dim acc_given_name As String = acc_name.Get("given_name") 
			If SubExists(mCallback, mEvent & "_Account") Then
				CallSub2(mCallback, mEvent & "_Account", root)
			End If
	  Case "getcurrentaccount"
			Dim parser As JSONParser
			parser.Initialize(res)
			Dim root As Map = parser.NextObject
			Dim accreferral_link As String = root.Get("referral_link")
			Dim accaccount_id As String = root.Get("account_id")
			Dim accemail As String = root.Get("email")
			Dim acclocale As String = root.Get("locale")
			Dim accname As Map = root.Get("name")
			Dim accdisplay_name As String = accname.Get("display_name")
			Dim accfamiliar_name As String = accname.Get("familiar_name")
			Dim accsurname As String = accname.Get("surname")
			Dim accgiven_name As String = accname.Get("given_name")
			Dim is_paired As String = root.Get("is_paired")
			Dim account_type As Map = root.Get("account_type")
				Dim tag As String = account_type.Get(".tag")
			Dim country As String = root.Get("country") 
			If SubExists(mCallback, mEvent & "_CurrentAccount") Then
				CallSub2(mCallback, mEvent & "_CurrentAccount", root)
			End If
    End Select
  Else
    Log("JobError: " & Job.ErrorMessage)
		ToastMessageShow("Error: " & Job.ErrorMessage,True)
  End If
	Job.Release           
End Sub
Sub GetFilename(fullpath As String) As String
   Return fullpath.SubString(fullpath.LastIndexOf("/") + 1)
End Sub
Sub GetBasename(fullpath As String) As String
   Dim filename As String
   filename = GetFilename(fullpath)
   Return filename.SubString2(0,filename.LastIndexOf("."))
End Sub
' Depends on: GetFilename
' Example
'Log(GetBasename("http://www.domain.tld/SomePage.html")) ' -> SomePage
Sub GetPath(Path As String) As String
   Dim Path1 As String
   If Path = "/" Then
      Return "/"
   End If
   Dim L As Int = Path.LastIndexOf("/")
   If L = Path.Length - 1 Then
      'Strip the last slash
      Path1 = Path.SubString2(0,L)
   Else
      Path1 = Path
   End If
   L = Path.LastIndexOf("/")
   If L = 0 Then
      L = 1
   End If
   Return Path1.SubString2(0,L)
End Sub
